/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package scan;
public class ICAPClient {
 protected byte[] bytes;
 public String clientIP = "127.0.0.1";
 private java.text.DateFormat dateFormat = new java.text.SimpleDateFormat(
  "yyyyMMddHHmmss");
 private java.io.BufferedReader input = null;
 private java.io.DataOutputStream output = null;
 private long previewBytes = 30;
 public String profileName = "default";
 private String[] results;
 private String selectedFile = "";
 // Defaults, if none are specified
 public String serverAddress = "192.168.11.122";
 public int serverPort = 1344;
 public String serviceName = "wwrespmod";
 private java.net.Socket socket = null;
 public ICAPClient() {}
 public ICAPClient(String serverAddress, int serverPort, String serviceName,
   String profileName, String clientIP) {
   setParams(serverAddress, serverPort, serviceName, profileName, clientIP);
  }
  // connect socket to ICAP server
 private int connect(String serverAddress, int serverPort) {
   int retValue = 0;
   if (this.socket == null) {
    try {
     java.net.InetAddress ip_address = java.net.InetAddress
      .getByName(serverAddress);
     this.socket = new java.net.Socket(ip_address, serverPort);
     this.socket.setSoTimeout(30000);
     this.output = new java.io.DataOutputStream(this.socket
      .getOutputStream());
     this.input = new java.io.BufferedReader(
      new java.io.InputStreamReader(this.socket
       .getInputStream()));
    } catch (Exception e) {
     retValue = -1;
     System.err.println("Error:connect(" + serverAddress + ":" + serverPort + "):" + e);
    }
   }
   return retValue;
  }
  // convert file to byte[]
 private byte[] convert() {
  long filelen = 0;
  try {
   java.io.File file = new java.io.File(this.selectedFile);
   java.io.InputStream is = new java.io.FileInputStream(file);
   filelen = file.length();
   this.bytes = new byte[(int) filelen];
   int offset = 0;
   int numRead = 0;
   while (offset < this.bytes.length && (numRead = is.read(this.bytes, offset, this.bytes.length - offset)) >= 0) {
    offset += numRead;
   }

   if (offset < this.bytes.length) {}

  } catch (Exception e) {
   System.err.println("Error:convert():" + e);
  }
  return this.bytes;
 }

 // disconnect socket
 private void disconnect() {
  try {
   // added: output.flush and changed order
   this.output.flush();
   this.output.close();
   this.input.close();
   //			this.output.close();
   this.socket.close();
   this.socket = null;
  } catch (Exception e) {
   System.err.println("Error:disconnect():" + e);
  }
 }

 public String optionsCheck() {
  String returnString = "nocheck";
  String profile = "";
  if (!"".equals(this.profileName)) {
   profile = "?profile=" + this.profileName;
  }
  String optionsString = "OPTIONS icap://" + this.serverAddress + ":" + this.serverPort + "/" + this.serviceName + profile + " ICAP/1.0\r\n" + "Host: " + this.serverAddress + "\r\n\r\n";

  if (connect(this.serverAddress, this.serverPort) > -1) {
   if (send(optionsString) > -1) {
    returnString = receive();
   } else {
    returnString = "Error:optionsCheck:send:" + optionsString;
   }
  } else {
   returnString = "Error:optionsCheck:connect:" + this.serverAddress + ":" + this.serverPort;
  }
  return optionsString + returnString;
 }

 // receive response from ICAP server
 private String receive() {
  String value = "  ";
  String returnString = new String();
  this.results = new String[1024];
  int array_location = 0;
  try {
   while ((value = this.input.readLine()) != null && value.length() != 0) {
    System.out.println("stdOut:" + value);
    returnString = returnString + value + "\n";
    this.results[array_location] = value;
    array_location++;
   }
  } catch (Exception e) {
   System.err.println("Error:receive():" + e);
   returnString = "Error:receive():" + e;
  }
  return returnString;
 }

 // enter here if you only want integer result codes
 public int resultCode(String returnString) {
  int retValue = 0;
  if (returnString.startsWith("Error") || returnString.startsWith("Undefined") || "".equals(returnString)) {
   retValue = -1;
  }

  if (returnString.startsWith("Infected") || returnString.startsWith("Blocked")) {
   if (returnString.contains(":")) {
    try {
     String[] responses = returnString.split(":", 3);
     retValue = Integer.parseInt(responses[1]);
    } catch (Exception e) {
     System.err.println("Error:scanfiletext:parsereturnString:" + returnString + ":" + e);
     retValue = 1;
    }
   }
  }

  if (returnString.startsWith("Clean")) {
   retValue = 0;
  }
  return retValue;
 }

 // enter here if you want text results
 public String scanFile(String fileName) {
  this.selectedFile = fileName;
  int retValue = 0;
  long fileLen = 0;
  String serverResponse = "";
  // check to see if file/path exists
  try {
   java.io.File file = new java.io.File(fileName);
   fileLen = file.length();
   if (fileLen < 1) {
    retValue = -1;
    serverResponse = "Error:scanfiletext:fileio:too_small:(" + fileLen + "):\"" + fileName + "\"";
   } else if (fileLen > 1 && (fileLen > Long.MAX_VALUE)) {
    retValue = -1;
    serverResponse = "Error:scanfiletext:fileio:too_large:(" + fileLen + "):\"" + fileName + "\"";
   }
  } catch (Exception e) {
   retValue = -1;
   serverResponse = "Error:scanfiletext:fileio:\"" + fileName + "\":" + e;
  }
  if (retValue < 0) {
   System.err.println(serverResponse);
   return serverResponse;
  }
  retValue = connect(this.serverAddress, this.serverPort);
  ICAPResponse icapResponse = new ICAPResponse();
  // where file is sent to be scanned.
  while (retValue == 0) {
   int req_header = 0;
   int res_header;
   int res_body;

   String requestHeader = "GET http://" + this.clientIP + "/" + dateFormat.format(new java.util.Date()) + "/" + fileName.substring(fileName.lastIndexOf(System
    .getProperty("file.separator")) + 1) + " HTTP/1.1\r\n" + "Host: " + this.clientIP + "\r\n\r\n";

   String responseHeader = "HTTP/1.1 200 OK\r\n" + "Transfer-Encoding: chunked\r\n\r\n";
   res_header = requestHeader.length();
   res_body = res_header + (responseHeader.length());
   String profile = "";
   if (!"".equals(this.profileName)) {
    profile = "?profile=" + this.profileName;
   }

   String icapRequest = "RESPMOD icap://" + this.serverAddress + ":" + this.serverPort + "/" + this.serviceName + profile + " ICAP/1.0\r\n" + "Allow: 204\r\n"
    // added connection: close
    + "Connection: close\r\n" + "Encapsulated: req-hdr=" + req_header + " res-hdr=" + res_header + " res-body=" + res_body + "\r\n" + "Host: " + this.serverAddress + "\r\n"
    //   + "Preview: " + Long.toString(this.previewBytes) + "\r\n"
    + "User-Agent: JavaICAPClient\r\n" + "X-Client-IP: " + this.clientIP + "\r\n\r\n";
   retValue = send(icapRequest);
   if (retValue == -1) {
    break;
   }
   retValue = send(requestHeader);
   if (retValue == -1) {
    break;
   }
   retValue = send(responseHeader);
   if (retValue == -1) {
    break;
   }

   //byte[] b = convert();
   try {
    int i = 0;
    byte[] chunk = new byte[4096];
    java.io.FileInputStream fis = null;
    try{
        java.io.File inputfile = new java.io.File(this.selectedFile);
        fis = new java.io.FileInputStream(inputfile);
    }
    catch (Exception e) {
    System.err.println("Error:cantcreateinputstream:" + e);
    retValue = -1;
    }
    while (i != -1){
         i = fis.read(chunk,0,chunk.length);
         if (i == -1)
           continue;
        //System.err.println("debug:i=" + i + ":"+Long.toHexString(i));
        retValue = send(Long.toHexString(i) + "\r\n");
        this.output.write(chunk, 0, i);
        retValue = send("\r\n");
        
    }
    retValue = send("0\r\n\r\n");
    this.output.flush();
    serverResponse = icapResponse.request(receive());

   } catch (Exception e) {
    System.err.println("Error:filesend:" + e);
    retValue = -1;
   }

   disconnect();
   break;
  }

  return serverResponse;
 }

 private int send(String str) {
  int retValue = 0;
  int counter = 0;
  try {
   this.output.write(str.getBytes());
   this.output.flush();
   counter++;
  } catch (Exception e) {
   System.err.println("Error:send(" + str + "):" + e);
   retValue = -1;
  }
  return retValue;
 }

 public void setParams(String serverAddress, int serverPort,
  String serviceName, String profileName, String clientIP) {
  this.serverAddress = serverAddress;
  this.serverPort = serverPort;
  this.serviceName = serviceName;
  this.profileName = profileName;
  this.clientIP = clientIP;
 }
}