/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package scan;
public class ICAPResponse {
 public boolean continue_check(String server_response) {
  boolean retValue = true;
  if (server_response.length() != 12) {
   server_response = server_response.substring(0, 12);
  }
  if (server_response.startsWith("ICAP/1.0 100")) {
   retValue = true;
  } else {
   retValue = false;
  }
  return retValue;
 }
 public String request(String serverResponse) {
  String returnString = "";
  String status = "Undefined";
  String blockResult = "";
  String virusName = ";";
  String[] lines = serverResponse.split("\n");
  for (int i = 0; i < lines.length; i++) {

   if (lines[i].startsWith("ICAP/1.0 204")) {
    status = "Clean:";
    blockResult = "0";
    virusName = "No malware detected;";
    break;
   }
   if (lines[i].startsWith("ICAP/1.0 200")) {
    status = "Blocked:";
    blockResult = "200";
    continue;
   }
   if (lines[i].startsWith("X-Virus-Name:")) {
    status = "Infected:";

    if ((lines[i].substring(14)).startsWith(virusName.substring(0, virusName.length() - 1))) {
     virusName = lines[i].substring(14);
    } else {
     virusName += lines[i].substring(14);
    }
    virusName += ";";
    continue;
   }
   if (lines[i].startsWith("X-WWBlockResult:")) {
    blockResult = lines[i].substring(17);
    switch (Integer.parseInt(blockResult)) {
     case 90:
      virusName += "Policy:Unwanted Unsigned Content;";
      break;
     case 81:
      virusName += "Policy:Authorization needed;";
      break;
     case 45:
      virusName += "Policy:Macros unwanted;";
      break;
     case 44:
      virusName += "Policy:Office document unreadable;";
      break;
     case 43:
      virusName += "Policy:Encrypted document unwanted;";
      break;
     case 42:
      virusName += "Policy:ActiveX unwanted;";
      break;
     case 41:
      virusName += "Policy:Document Inspector;";
      break;
     case 40:
      virusName += "Policy:Text Categorization unwanted;";
      break;
     case 34:
      virusName += "Policy:Encrypted archive unwanted;";
      break;
     case 33:
      virusName += "Policy:Archive recursion level exceeded;";
      break;
     case 32:
      virusName += "Policy:Mailbomb unwanted;";
      break;
     case 31:
      virusName += "Policy:Corrupted archive unwanted;";
      break;
     case 30:
      virusName += "Policy:Multipart archive unwanted;";
      break;
     case 23:
      virusName += "Policy:Generic Body Filter;";
      break;
     case 22:
      virusName += "Policy:Media type blacklisted;";
      break;
     case 21:
      virusName += "Policy:Media type mismatch;";
      break;
     default:
      status = "Infected:";
      break;
    }
    continue;
   }

   if (lines[i].startsWith("ICAP/1.0 ")) {
    status = "Error:" + lines[i];
   }
  }
  if (virusName.endsWith(";"))
   virusName = virusName.substring(0, virusName.length() - 1);
  virusName.trim();
  if ("".equals(virusName))
   virusName = "Unknown";
  returnString = status + blockResult + ":\"" + virusName + "\"";
  return returnString;
 }
}